<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        $sql = <<<'SQL'
            CREATE TABLE equipment_masters (
                id					               	BIGINT GENERATED always AS IDENTITY PRIMARY KEY,
                plant_id							BIGINT NOT NULL,
                machine_id							BIGINT NOT NULL,
                name							   	TEXT DEFAULT NULL,
                description						   	TEXT DEFAULT NULL,
                make							  	TEXT DEFAULT NULL,
                model								TEXT DEFAULT NULL,
                equipment_number					TEXT DEFAULT NULL,
                instrument_serial_number			TEXT DEFAULT NULL,
                calibrated_on						TIMESTAMP NOT NULL DEFAULT NOW(),
                frequency							INT NOT NULL DEFAULT (1),
                next_calibration_date				TIMESTAMP NOT NULL DEFAULT NOW(),
                calibrated_by						TEXT DEFAULT NULL,
                calibration_certificate				TEXT DEFAULT NULL,
                created_at							TIMESTAMP NOT NULL DEFAULT NOW(),
                updated_at							TIMESTAMP NOT NULL DEFAULT NOW(),
                created_by							TEXT DEFAULT NULL,
                updated_by							TEXT DEFAULT NULL,
                deleted_at			                TIMESTAMP,

                unique(plant_id, equipment_number),
                FOREIGN KEY (plant_id)             REFERENCES  plants (id),
                FOREIGN KEY (machine_id)           REFERENCES machines(id)

            );
        SQL;
        DB::statement($sql);
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('equipment_masters');
    }
};
